/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Toggle Word Wrap.
 *
 * The Initial Developer of the Original Code is
 * Kaspar Brand.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/* $Id: toggleWordWrap.js 30 2006-06-17 09:23:42Z kbrand $ */

function toggleWordWrap()
{
  if (!gMsgCompose || gMsgCompose.composeHTML)
    return;

  if (gMsgCompose.editor.QueryInterface(nsIPlaintextEditorMail).wrapWidth > 0) {
    try {
      gMsgCompose.editor.QueryInterface(nsIPlaintextEditorMail).wrapWidth = 0 
    }
    catch (e) { }
  } else {
    try {
      gMsgCompose.editor.QueryInterface(nsIPlaintextEditorMail).wrapWidth = gMsgCompose.wrapLength;
    }
    catch (e) { }
  }
}

function checkToggleWordWrapMenuEntry()
{
  if (!gMsgCompose || gMsgCompose.composeHTML) {
    document.getElementById("menu_togglewordwrap")
            .setAttribute('disabled', true);
  } else {
    document.getElementById("menu_togglewordwrap")
            .setAttribute('checked',gMsgCompose.editor
            .QueryInterface(nsIPlaintextEditorMail).wrapWidth == 0 ?
            false : true);
    document.getElementById("menu_togglewordwrap")
            .setAttribute('disabled', false);
  }
}

function togglePreWrap()
{
  var elem = window.content.document.getElementById("toggleprewrap");
  if (elem) {
    elem.parentNode.removeChild(elem);
    refreshTableDisplay();
    document.getElementById("menu_toggleprewrap").setAttribute('checked', false);
  } else {
    var headElem = window.content.document.getElementsByTagName("head")[0];
    if (!headElem) {
      document.getElementById("menu_toggleprewrap").setAttribute('disabled', true);
      document.getElementById("context-toggleprewrap").setAttribute('disabled', true);
      return;
    }
    elem = window.content.document.createElement("style");
    elem.id = "toggleprewrap";
    elem.type = "text/css";
    elem.innerHTML = "pre { white-space: -moz-pre-wrap !important; } /* inserted by the Toggle Word Wrap extension */";
    headElem.appendChild(elem);
    refreshTableDisplay();
    document.getElementById("menu_toggleprewrap").setAttribute('checked', true);
  }
}

function refreshTableDisplay()
{
  var table = window.content.document.getElementsByTagName("table");
  if (table) {
    for (var i = 0; i < table.length; i++) {
      // trick Firefox into rewrapping the table
      var temprow = table[i].insertRow(-1);
      table[i].deleteRow(-1);
    }
  }
}

function checkTogglePreWrapMenuEntry()
{
  var elem = window.content.document.getElementById("toggleprewrap");
  if (elem) {
    document.getElementById("menu_toggleprewrap").setAttribute('checked', true);
    document.getElementById("context-toggleprewrap").setAttribute('checked', true);
  } else {
    document.getElementById("menu_toggleprewrap").setAttribute('checked', false);
    document.getElementById("context-toggleprewrap").setAttribute('checked', false);
  }
  if (window.content.document.getElementsByTagName("head")[0]) {
    document.getElementById("menu_toggleprewrap").setAttribute('disabled', false);
    document.getElementById("context-toggleprewrap").setAttribute('disabled', false);
  } else {
    document.getElementById("menu_toggleprewrap").setAttribute('disabled', true);
    document.getElementById("context-toggleprewrap").setAttribute('disabled', true);
  }
}
